using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.CompilerServices;

namespace ResolutionTest
{
    class Program
    {
        static void Main(string[] args)
        {
             try
             {
                new MainClass();
            }
            catch (Exception ex)
            {
                Console.Out.WriteLine("ERROR!");
                Console.Out.WriteLine(ex.ToString());
            }
            Console.Out.WriteLine("Press a key to exit.");
            Console.In.Read();           
        }

        /// <summary>
        /// This is only made into an instance class in an attempt to demonstrate inlining. 
        /// 
        /// Static methods are never inlined in C# (apparently, although they weren't inlined here either.)
        /// </summary> 
        private class MainClass
        {
            public MainClass()
            {               
                Console.Out.WriteLine("MainClass constructor executing...");                
                SubMethod();           
            }

            //[MethodImpl(MethodImplOptions.NoInlining)] // This doesn't seem to make any difference for me
            private void SubMethod()
            {
                //Console.Out.WriteLine("Program.SubMethod() Executing...");
                MissingClass missing = new MissingClass();
                //Console.Out.WriteLine("MissingClass object created.");
            }
        }
    }
}
